#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <util.h>

int main(int argc, char * argv[]) {

    if (argc == 1) {
	fprintf(stderr, "usa: %s file1 [fileN]\n", argv[0]);
	return EXIT_FAILURE;
    }
    
    char buffer[BUFSIZE];
    
    for(int i=1;i<argc;++i) {
	int fd;
	SYSCALL_PRINT(open, fd, open(argv[i],O_RDONLY), "Aprendo il file %s: errno=%d\n", argv[i], errno);
	if (fd < 0) continue;  // vado avanti anche se ci sono errori

	size_t len;
	do {
	    SYSCALL_PRINT(read,len,read(fd,buffer,BUFSIZE),"Leggendo il file %s : errno=%d\n", argv[i], errno);
	    if (len < 0) break; // vado avanti anche se ci sono errori
	    int r;
	    SYSCALL_PRINT(write,r, write(STDOUT_FILENO,buffer,len), "Scrivendo sullo stdout: errno=%d\n",errno);
	    if (r < 0 || r < len)  break; // vado avanti anche se ci sono errori.
	    // NOTA: la write su **file regolari** puo' (raramente) ritornare un valore di bytes scritto minore di 
	    //       quello richiesto. Questo avviene tipicamente perche' il disco/partizione è pieno oppure
	    //       se si e' raggiunta la massima size per un file.
	} while (len>0);

	SYSCALL(close,len,close(fd),"Chiudendo il file %s: errno=%d\n",argv[1],errno);
    }
    return 0;
}
